// QT؃NXBinTree<K,V>̗p

import java.util.Scanner;

class BinTreeTester {
	static Scanner stdIn = new Scanner(System.in);

	//--- f[^iԍ{j ---//
	static class Data {
		public static final int NO   = 1;	// ԍǂݍނH
		public static final int NAME = 2;	// ǂݍނH

		private Integer no;						// ԍiL[lj
		private String  name;					// 

		//--- L[l ---//
		Integer keyCode() {
			return no;
		}

		//--- \Ԃ ---//
		public String toString() {
			return name;
		}

		//--- f[^̓Ǎ ---//
		void scanData(String guide, int sw) {
			System.out.println(guide + "f[^͂ĂB");

			if ((sw & NO) == NO) {
				System.out.print("ԍF");
				no = stdIn.nextInt();
			}
			if ((sw & NAME) == NAME) {
				System.out.print("OF");
				name = stdIn.next();
			}
		}
	}

	//--- j[񋓌^ ---//
	enum Menu {
		ADD(      "}"),
		REMOVE(   "폜"),
		SEARCH(   "T"),
		PRINT(    "\"),
		TERMINATE("I");

		private final String message;			// \p

		static Menu MenuAt(int idx) {			// idxł񋓂Ԃ
			for (Menu m : Menu.values())
				if (m.ordinal() == idx)
					return m;
			return null;
		}

		Menu(String string) {				// RXgN^
			message = string;
		}

		String getMessage() {				// \pԂ
			return message;
		}
	}

	//--- j[I ---//
	static Menu SelectMenu() {
		int key;
		do {
			for (Menu m : Menu.values())
				System.out.printf("(%d) %s  ", m.ordinal(), m.getMessage());
			System.out.print("F");
			key = stdIn.nextInt();
		} while (key < Menu.ADD.ordinal() || key > Menu.TERMINATE.ordinal());

		return Menu.MenuAt(key);
	}

	public static void main(String[] args) {
		Menu menu;					// j[
		Data data;					// ǉpf[^Q
		Data ptr;					// Tpf[^Q
		Data temp = new Data();		// Ǎݗpf[^
		BinTree<Integer, Data> tree = new BinTree<Integer, Data>();

		do {
			switch (menu = SelectMenu()) {
			 case ADD :				// m[h̑}
					data = new Data();
			 		data.scanData("}", Data.NO | Data.NAME);
			 		tree.add(data.keyCode(), data);
			 		break;

			 case REMOVE :			// m[h̍폜
					temp.scanData("폜", Data.NO);
			 		tree.remove(temp.keyCode());
			 		break;

			 case SEARCH :			// m[h̒T
					temp.scanData("T", Data.NO);
			 		ptr = tree.search(temp.keyCode());
			 		if (ptr != null)
						System.out.println("̔ԍ̎" + ptr + "łB");
					else
			 			System.out.println("Yf[^͂܂B");
			 		break;

			 case PRINT :			// Sm[hL[l̏ɕ\
					tree.print();
					break;
			}
		} while (menu != Menu.TERMINATE);
	}
}
