// I[vAhX@ɂnbV̗p

import java.util.Scanner;

public class OpenHashTester {

	static Scanner stdIn = new Scanner(System.in);

	//--- f[^iԍ{j ---//
	static class Data {
		static final int NO   = 1;		// ԍǂݍނH
		static final int NAME = 2;		// ǂݍނH

		private Integer no;				// ԍiL[lj
		private String  name;			// 

		//--- L[l ---//
		Integer keyCode() {
			return no;
		}

		//--- \Ԃ ---//
		public String toString() {
			return name;
		}

		//--- f[^̓Ǎ ---//
		void scanData(String guide, int sw) {
			System.out.println(guide + "f[^͂ĂB");

			if ((sw & NO) == NO) {
				System.out.print("ԍF");
				no = stdIn.nextInt();
			}
			if ((sw & NAME) == NAME) {
				System.out.print("F");
				name = stdIn.next();
			}
		}
	}

	//--- j[񋓌^ ---//
	enum Menu {
		ADD(      "ǉ"),
		REMOVE(   "폜"),
		SEARCH(   "T"),
		DUMP(     "\"),
		TERMINATE("I");

		private final String message;			// \p

		static Menu MenuAt(int idx) {			// idxł񋓂Ԃ
			for (Menu m : Menu.values())
				if (m.ordinal() == idx)
					return m;
			return null;
		}

		Menu(String string) {					// RXgN^
			message = string;
		}

		String getMessage() {					// \pԂ
			return message;
		}
	}

	//--- j[I ---//
	static Menu SelectMenu() {
		int key;
		do {
			for (Menu m : Menu.values())
				System.out.printf("(%d) %s  ", m.ordinal(), m.getMessage());
			System.out.print("F");
			key = stdIn.nextInt();
		} while (key < Menu.ADD.ordinal() || key > Menu.TERMINATE.ordinal());

		return Menu.MenuAt(key);
	}

	public static void main(String[] args) {
		Menu menu;					// j[
		Data data;					// ǉpf[^Q
		Data temp = new Data();	// Ǎݗpf[^

		OpenHash<Integer, Data> hash = new OpenHash<Integer, Data>(13);

		do {
			switch (menu = SelectMenu()) {
			 case ADD :									// ǉ
				data = new Data();
				data.scanData("ǉ", Data.NO | Data.NAME);
			 	int k = hash.add(data.keyCode(), data);
			 	switch (k) {
			 	 case 1: System.out.println("̃L[l͓o^݂łB");
			 	 			break;
			 	 case 2: System.out.println("nbV\tłB");
			 	 			break; 
			 	}
			 	break;

			 case REMOVE :								// 폜
			 	temp.scanData("폜", Data.NO);
			 	hash.remove(temp.keyCode());
			 	break;

			 case SEARCH :								// T
				temp.scanData("T", Data.NO);
			 	Data t = hash.search(temp.keyCode());
			 	if (t != null)
			 		System.out.println("̃L[f[^" + t + "łB");
				else
		 			System.out.println("Yf[^͂܂B");
			 	break;

			 case DUMP : 								// \
			 	hash.dump();
			 	break;
			}
		} while (menu != Menu.TERMINATE);
	}
}